package edu.uoc.baserrikoa.Control;

import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.media.RingtoneManager;
import android.support.v4.app.NotificationCompat;

import com.google.firebase.messaging.RemoteMessage;

import edu.uoc.baserrikoa.R;
import edu.uoc.baserrikoa.Control.ofertas.DescuentoListActivity;
import edu.uoc.baserrikoa.model.SesionData;

public class FirebaseMessagingService extends com.google.firebase.messaging.FirebaseMessagingService {

    private static final String TAG = "FirebaseMsgService";

    /**
     * Método llamado cuando se recibe un mensaje remoto
     *
     * @param remoteMessage Mensaje recibido de Firebase Cloud Messaging.
     */
    @Override
    public void onMessageReceived(RemoteMessage remoteMessage) {

        if(SesionData.firebaseConected){
            sendExtendedNotification( remoteMessage.getData().get("message"));
        }
    }

    private void sendExtendedNotification(String message){
        Intent intent2 = new Intent(this, DescuentoListActivity.class);
        intent2.setAction(Intent.ACTION_SEND);

        PendingIntent resendIntent = PendingIntent.getActivity(this, (int) System.currentTimeMillis(), intent2, 0);

        NotificationCompat.Builder mBuilder =
                new NotificationCompat.Builder(this)
                        .setSmallIcon(R.drawable.book_white)
                        .setContentTitle("Nuevo descuento")
                        .setVisibility(NotificationCompat.VISIBILITY_PUBLIC)
                        .setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION))
                        .setStyle(new NotificationCompat.BigTextStyle().bigText(message))
                                        .addAction(new NotificationCompat.Action(R.drawable.details, "Ver descuentos", resendIntent));

        mBuilder.setLights(Color.BLUE, 1000,500);
        NotificationManager mNotificationManager =
                (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        mNotificationManager.notify(3, mBuilder.build());
    }
}