package edu.uoc.baserrikoa.Control;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.TextView;

import edu.uoc.baserrikoa.LoginActivity;
import edu.uoc.baserrikoa.R;
import edu.uoc.baserrikoa.Control.comprasAnteriores.CompraListActivity;
import edu.uoc.baserrikoa.Control.ofertas.DescuentoListActivity;
import edu.uoc.baserrikoa.Control.productor.VendedorListActivity;
import edu.uoc.baserrikoa.model.SesionData;
import edu.uoc.baserrikoa.Control.usuario.UserDetailActivity;

/*Actividad que gestiona el menú principal de la aplicación*/
public class MenuActivity extends AppCompatActivity {

    TextView menuProductores;
    TextView menuCompras;
    TextView menuPromociones;
    TextView menuUsuario;
    TextView menuCerrarSesion;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_menu);

        menuProductores = (TextView) findViewById(R.id.menu_productores);
        menuProductores.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                changeActivity(VendedorListActivity.class);
            }
        });

        menuCompras = (TextView) findViewById(R.id.menu_compras);
        menuCompras.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                changeActivity(CompraListActivity.class);
            }
        });

        menuPromociones = (TextView) findViewById(R.id.menu_promociones);
        menuPromociones.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                changeActivity(DescuentoListActivity.class);
            }
        });

        menuUsuario = (TextView) findViewById(R.id.menu_usuario);
        menuUsuario.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                changeActivity(UserDetailActivity.class);
            }
        });

        menuCerrarSesion = (TextView) findViewById(R.id.menu_sesion);
        menuCerrarSesion.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                SesionData.signOut();
                changeActivity(LoginActivity.class);
            }
        });


    }


    private void changeActivity(Class act){
        Intent intent = new Intent(this, act);
        startActivity(intent);
    }
}
