package edu.uoc.baserrikoa.Control.carrito;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;

import com.google.firebase.database.DatabaseReference;

import java.text.DateFormat;
import java.util.Date;

import edu.uoc.baserrikoa.Control.MenuActivity;
import edu.uoc.baserrikoa.Control.MenuManagementActivity;
import edu.uoc.baserrikoa.R;
import edu.uoc.baserrikoa.model.CarritoContent;
import edu.uoc.baserrikoa.model.SesionData;

public class PaymentActivity extends MenuManagementActivity {

    String compraId;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_payment);

        //Calcular coste total
        Float coste = 0f;
        for (CarritoContent.CarritoItem item:CarritoContent.getCarrito()) {
            coste += Float.parseFloat(item.cantidad) *  Float.parseFloat(item.coste);
        }

        TextView totalView = (TextView) findViewById(R.id.carrito_total);
        totalView.setText("Total: "+coste+" €");


        Spinner spinner = (Spinner) findViewById(R.id.spinner);
        String[] horas = {"10:00","11:00","12:00","13:00","19:00","20:00"};
        spinner.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, horas));

        Button comprar = (Button) findViewById(R.id.carrito_confirmar);
        comprar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                enviarCompraGeneral();
                enviarProductosComprados();

                //Mostrar alerta de compra realizada
                AlertDialog.Builder builder = new AlertDialog.Builder(PaymentActivity.this);
                builder.setMessage("Compra realizada con éxito")
                        .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int id) {
                                Intent intent = new Intent(PaymentActivity.this, MenuActivity.class);
                                startActivity(intent);
                            }
                        });
                CarritoContent.vaciarCarrito();
               builder.create();
               builder.show();


            }
        });
    }


    /**
     * Función que envía al servidor Firebase los datos generales de la compra realizada.
     */
    public void enviarCompraGeneral(){
        Date fecha = new Date();
        compraId = fecha.toString();
        DatabaseReference myRef = SesionData.database.getReference("compras").child(SesionData.userID).child(compraId);

        String stringDate = DateFormat.getDateInstance().format(fecha);
        Float coste = 0f;
        for (CarritoContent.CarritoItem item:CarritoContent.getCarrito()) {
            coste += Float.parseFloat(item.cantidad) *  Float.parseFloat(item.coste);
        }

        myRef.child("idcompra").setValue(compraId);
        myRef.child("fecha").setValue(stringDate);
        myRef.child("coste").setValue(String.format("%.2f", coste));

    }

    /**
     * Función que envía la lista de la compra al servidor Firebase
     * */
    public void enviarProductosComprados(){
        DatabaseReference myRef = SesionData.database.getReference("productosCompras").child(compraId);
        Integer i = 0;
        for (CarritoContent.CarritoItem item:CarritoContent.getCarrito()) {
            myRef.child(i.toString()).child("idproducto").setValue(item.idproducto);
            myRef.child(i.toString()).child("nombre").setValue(item.nombre);
            myRef.child(i.toString()).child("coste").setValue(item.coste);
            myRef.child(i.toString()).child("cantidad").setValue(item.cantidad);

            i++;
        }
    }
}
