package edu.uoc.baserrikoa.Control.ofertas;

import android.app.Activity;
import android.os.Bundle;
import android.support.design.widget.CollapsingToolbarLayout;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;

import edu.uoc.baserrikoa.R;
import edu.uoc.baserrikoa.model.DescuentoContent;

/**
 * Fragmento que representa la información relativa a un solo descuento
 * contenido en  {@link DescuentoListActivity}
 */
public class DescuentoDetailFragment extends Fragment {
    /**
     * ID que representa este fragmento
     */


    public static final String ARG_ITEM_ID = "item_id";

    /**
     * Item que representa el fragment
     */
    private DescuentoContent.DescuentoItem mItem;

    private ImageView imageHeader;

    /**
     * Constructor vacío obligatorio
     */
    public DescuentoDetailFragment() {
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if (getArguments().containsKey(ARG_ITEM_ID)) {

            Integer pos = getArguments().getInt(ARG_ITEM_ID);
            mItem = DescuentoContent.getDescuentos().get(pos);

            Log.d("FRAGMENT: ",""+pos);
            Activity activity = this.getActivity();
            CollapsingToolbarLayout appBarLayout = (CollapsingToolbarLayout) activity.findViewById(R.id.toolbar_layout);
            if (appBarLayout != null) {
                appBarLayout.setTitle(mItem.getNombre());
            }
            imageHeader = (ImageView) activity.findViewById(R.id.image_header);
            if (imageHeader != null) {
                Picasso.with(getActivity()).load(mItem.getImagen()).into(imageHeader);
            }

        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.descuento_detail, container, false);


        // Mostrar el contenido.
        if (mItem != null) {
            ((TextView) rootView.findViewById(R.id.descuento_nombre)).setText(mItem.nombre);
            ((TextView) rootView.findViewById(R.id.descuento_cantidad)).setText(mItem.cantidad);
            ((TextView) rootView.findViewById(R.id.descuento_validez)).setText(mItem.validez);
            ImageView imageView1 = (ImageView) rootView.findViewById(R.id.descuento_imagen);

            if (imageHeader != null) {
                imageView1.setVisibility(View.GONE);
            } else {
                Picasso.with(getActivity()).load(mItem.imagen).into(imageView1);
            }
        }

        return rootView;
    }

}
