package edu.uoc.baserrikoa.Control.productor.Producto;

import android.app.Activity;
import android.os.Bundle;
import android.support.design.widget.CollapsingToolbarLayout;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;

import edu.uoc.baserrikoa.R;
import edu.uoc.baserrikoa.model.ProductContent;

/**
 * A fragment representing a single Product detail screen.
 * This fragment is either contained in a {@link ProductListActivity}
 * in two-pane mode (on tablets) or a {@link ProductDetailActivity}
 * on handsets.
 */
public class ProductDetailFragment extends Fragment {
    /**
     * The fragment argument representing the item ID that this fragment
     * represents.
     */


    public static final String ARG_ITEM_ID = "item_id";

    /**
     * The  content this fragment is presenting.
     */
    private ProductContent.ProductItem mItem;

    private ImageView imageHeader;

    /**
     * Mandatory empty constructor for the fragment manager to instantiate the
     * fragment (e.g. upon screen orientation changes).
     */
    public ProductDetailFragment() {
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if (getArguments().containsKey(ARG_ITEM_ID)) {

            Integer pos = getArguments().getInt(ARG_ITEM_ID);
            mItem = ProductContent.getProducts().get(pos);

            Log.d("FRAGMENT: ",""+pos);
            Activity activity = this.getActivity();
            CollapsingToolbarLayout appBarLayout = (CollapsingToolbarLayout) activity.findViewById(R.id.toolbar_layout);
            if (appBarLayout != null) {
                appBarLayout.setTitle(mItem.getNombre());
            }
            imageHeader = (ImageView) activity.findViewById(R.id.image_header);
            if (imageHeader != null) {
                Picasso.with(getActivity()).load(mItem.getImagen()).into(imageHeader);
            }

        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.product_detail, container, false);


        // Show the dummy content as text in a TextView.
        if (mItem != null) {
            ((TextView) rootView.findViewById(R.id.product_nombre)).setText(mItem.nombre);
            ((TextView) rootView.findViewById(R.id.product_precio)).setText(mItem.precio);
            ((TextView) rootView.findViewById(R.id.product_descripcion)).setText(mItem.descripcion);
            ImageView imageView1 = (ImageView) rootView.findViewById(R.id.product_imagen);

            if (imageHeader != null) {
                imageView1.setVisibility(View.GONE);
            } else {
                Picasso.with(getActivity()).load(mItem.imagen).into(imageView1);
            }
        }

        return rootView;
    }
}
