package edu.uoc.baserrikoa.Control.productor;

import android.app.ActivityOptions;
import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.ActionBar;
import android.support.v7.widget.Toolbar;
import android.view.View;

import edu.uoc.baserrikoa.Control.MenuManagementActivity;
import edu.uoc.baserrikoa.Control.productor.Producto.ProductListActivity;
import edu.uoc.baserrikoa.R;

/**
 * An activity representing a single Vendedor detail screen. This
 * activity is only used narrow width devices. On tablet-size devices,
 * item details are presented side-by-side with a list of items
 * in a {@link VendedorListActivity}.
 */
public class VendedorDetailActivity extends MenuManagementActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_vendedor_detail);
        Toolbar toolbar = (Toolbar) findViewById(R.id.detail_toolbar);
        setSupportActionBar(toolbar);

        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab_tienda);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                Bundle animation = ActivityOptions.makeCustomAnimation(VendedorDetailActivity.this, R.anim.translate_in_bottom,
                        R.anim.translate_out_bottom).toBundle();
                Intent intent = new Intent(VendedorDetailActivity.this, ProductListActivity.class);
                intent.putExtra("vendedor_id", VendedorDetailFragment.vendedorId );
                startActivity(intent, animation);

            }
        });

        // Show the Up button in the action bar.
        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.setDisplayHomeAsUpEnabled(true);
        }

        if (savedInstanceState == null) {
            // Create the detail fragment and add it to the activity
            // using a fragment transaction.
            Bundle arguments = new Bundle();
            arguments.putInt(VendedorDetailFragment.ARG_ITEM_ID,
                    getIntent().getIntExtra(VendedorDetailFragment.ARG_ITEM_ID, 0));
            VendedorDetailFragment fragment = new VendedorDetailFragment();
            fragment.setArguments(arguments);
            getSupportFragmentManager().beginTransaction()
                    .add(R.id.vendedor_detail_container, fragment)
                    .commit();
        }
    }
}
