package edu.uoc.baserrikoa.model;

import com.orm.SugarRecord;

import java.util.List;

/**
 * Helper class for providing sample content for user interfaces created by
 * Android template wizards.
 */
public class CarritoContent {

    public static List<CarritoItem> getCarrito(){
        return CarritoItem.listAll(CarritoItem.class);
    }

    public static boolean exists(CarritoItem productosCarritoItem) {
        List<CarritoItem> productosCarritoItem1 = CarritoItem.find(CarritoItem.class, "idproducto = ?", productosCarritoItem.idproducto);
        if (productosCarritoItem1 == null || productosCarritoItem1.size() == 0) {
            return false;
        } else {
            return true;
        }
    }

    public static boolean exists(String id) {
        List<CarritoItem> productosCarritoItem1 = CarritoItem.find(CarritoItem.class, "idproducto = ?",id);
        if (productosCarritoItem1 == null || productosCarritoItem1.size() == 0) {
            return false;
        } else {
            return true;
        }
    }

    public static void actualizarCantidad (int sumando, String id) {
        List<CarritoItem> productosCarritoItem1 = CarritoItem.find(CarritoItem.class, "idproducto = ?",id);
        if (!(productosCarritoItem1 == null || productosCarritoItem1.size() == 0)) {
            Integer total = Integer.parseInt(productosCarritoItem1.get(0).cantidad)+sumando;
            productosCarritoItem1.get(0).cantidad = total.toString();
        }
    }


    public static void vaciarCarrito(){
        CarritoItem.deleteAll(CarritoItem.class);
    }

    public static CarritoItem getItemWithCarritoID(String id) {
        List<CarritoItem> productosCarritoItem1 = CarritoItem.find(CarritoItem.class, "idproducto = ?", id);
        if (productosCarritoItem1 == null || productosCarritoItem1.size() == 0) {
            return new CarritoItem();
        } else {
            return productosCarritoItem1.get(0);
        }
    }


    /**
     * A product item representing a product in the market.
     */
    public static class CarritoItem extends SugarRecord {
        public String idproducto;
        public String nombre;
        public String coste;
        public String cantidad;

        public CarritoItem() {

        }

        public CarritoItem(String idProducto, String nombre, String coste, String cantidad) {
            this.idproducto = idProducto;
            this.nombre = nombre;
            this.coste = coste;
            this.cantidad = cantidad;
        }

        @Override
        public String toString() {
            return idproducto;
        }
    }
}
