package edu.uoc.baserrikoa.model;

import com.orm.SugarRecord;

import java.util.List;

/**
 * Helper class for providing sample content for user interfaces created by
 * Android template wizards.
 */
public class ProductContent{

    public static List<ProductItem> getProducts(){
        return ProductItem.listAll(ProductItem.class);
    }

    public static boolean exists(ProductItem productItem) {
        List<ProductItem> prodItem1 = ProductItem.find(ProductItem.class, "id = ?", productItem.id);
        if (prodItem1 == null || prodItem1.size() == 0) {
            return false;
        } else {
            return true;
        }
    }



    /**
     * A product item representing a product in the market.
     */
    public static class ProductItem extends SugarRecord {
        public String id;
        public String nombre;
        public String tipo;
        public String precio;
        public String imagen;
        public String vendedor;
        public String descripcion;

        public ProductItem() {

        }

        public ProductItem(String id, String nombre, String tipo, String precio, String imagen, String vendedor, String descripcion) {
            this.id = id;
            this.nombre = nombre;
            this.tipo = tipo;
            this.precio = precio;
            this.imagen = imagen;
            this.vendedor = vendedor;
            this.descripcion = descripcion;
        }

        @Override
        public String toString() {
            return nombre;
        }

        public String getNombre() {
            return nombre;
        }

        public void setNombre(String nombre) {
            this.nombre = nombre;
        }

        public String getTipo() {
            return tipo;
        }

        public void setTipo(String tipo) {
            this.tipo = tipo;
        }

        public String getPrecio() {
            return precio;
        }

        public void setPrecio(String precio) {
            this.precio = precio;
        }

        public String getImagen() {
            return imagen;
        }

        public void setImagen(String imagen) {
            this.imagen = imagen;
        }

        public String getVendedor() {
            return vendedor;
        }

        public void setVendedor(String vendedor) {
            this.vendedor = vendedor;
        }

        public String getDescripcion() {
            return descripcion;
        }

        public void setDescripcion(String descripcion) {
            this.descripcion = descripcion;
        }
    }
}
